% Programa para generar los parámetros de una elipse
% a , b, Xc, Yc, alfa,
% a partir de la matriz que representa una cónica (elipse)
% Fraga 28/06/2001
% 

E1 = [ 1.6141e-03  -6.6626e-04  -3.6438e-01;
  -6.6626e-04   1.7228e-03  -1.3015e-01;
  -3.6438e-01  -1.3015e-01   1.1951e+02 ];

E2 = [ 1.6221e-03  -6.7488e-04  -3.5499e-01;
  -6.7488e-04   1.7322e-03  -1.4034e-01;
  -3.5499e-01  -1.4034e-01   1.3061e+02 ];

# Como es una simulación podemos saber 
# la raíces :
# beta1 = E2(3,3)/E1(3,3)
# beta3 = (E2(3,3)/E1(3,3))*(1.0/0.5)^2




E1 = E2;
a = E1(1,1);
b = E1(1,2);
c = E1(2,2);
d = E1(1,3);
e = E1(2,3); 
g = E1(3,3);

angulo =  atan (  2.0 * b / (a - c) )*90.0/pi;

aux3 = b*b - a*c;

xc = (c*d - b*e)/aux3;
yc = (a*e - b*d)/aux3;


aux1 = abs( 2.0 * ( a*e*e+ c*d*d + g*b*b - 2.0*b*d*e - a*c*g ) );
aux2 = abs( (b*b-a*c) * ( (c-a)*sqrt(1.0 + ( (4.0*b*b)/((a-c)*(a-c)) ) ) - (c+a) ) );
aux3 = abs( (b*b-a*c) * ( (a-c)*sqrt(1.0 + ( (4.0*b*b)/((a-c)*(a-c)) ) ) - (c+a) ) );

eje_a = sqrt ( aux1 / aux2);
eje_b = sqrt ( aux1 / aux3);

if( eje_a < eje_b ) 
	aux1 = eje_a;
	eje_a = eje_b;
	eje_b = aux1;
	if( angulo < 0 )
         angulo += 90.0;
	else
		angulo -= 90.0;
	end
end
printf("a = %f \n", eje_a);
printf("b = %f \n", eje_b);
printf("Xc = %f\n", xc );
printf("Yc = %f\n", yc );
printf("ang = %f \n", angulo);

