# Proyectamos dos circulos de radio 1 y 0.5,
# según una homografía H
#
# Fraga 1/08/2018

# Un circulo de radio 1 
C1 = [ 1 0 0;
       0 1 0;
       0 0 -1 ];

# Otro circulo de radio 0.5 
C2 = [ 1 0  0;
       0 1  0;
       0 0 -0.25 ];

# La cámara, f=1000,
#  y el punto principal en (300,200) 
#
K = [ 1000    0 -300;
         0 1000 -200;
         0    0   -1 ];

# El modelo de la cámara obscura
# lp = K R[ I| -c] P 
# lp = H P

# Para calcular R, necesitamos 
# vc, la posición de la cámara
# vo, un punto sobre el objeto al que ve la cámara
# va, el vector arriba

vc = [ 3;
      -5;
       5 ];

va = [ 0;
       1;
       0 ];

z = vc/norm(vc);
vtmp = cross( va, z);
x = vtmp/norm( vtmp );
y = cross( z, x );

R = [ x';
      y';
      z' ]

M = eye( 3 );
M(:,3)  = -vc;

H = K * R * M
Hinv = inv( H )

# La elipse1
E1 = 1000.0 * Hinv' * C1 * Hinv

# La elipse1
E2 = 1000.0 * Hinv' * C2 * Hinv

# Proyectamos el centro de los círculos
vp = H * [0; 0; 1];
x = vp(1)/vp(3) 
y = vp(2)/vp(3) 
